<template>
  <div class="search-map">
    <client-only>
      <mapbox-map
        class="search-map__container"
        access-token="pk.eyJ1IjoiYWxleGtoYXJlY2giLCJhIjoiY2tibnNqc3EyMXZxdjMwcGptcGFjZ3pidCJ9.gGDpAP5xsODsXr2kI6yfUg"
        map-style="mapbox://styles/alexkharech/ckdj217qt152z1itlob2njbl4?v2"
        :center="[37.617635, 55.755814]"
        :zoom="0"
        :doubleClickZoom="false"
      >
        <mapbox-marker
          v-for="(item, index) in result"
          :key="index"
          :lng-lat="[
            item.location.geo.coordinates[1],
            item.location.geo.coordinates[0]
          ]"
        >
          <Avatar
            :user="item"
            :size="40"
            :class="{ 'profile-is-active': indexActive == index }"
            @click.native="onActive(index, item, item.location.geo)"
          />
        </mapbox-marker>
        <mapbox-geolocate-control position="bottom-right" />
        <mapbox-navigation-control position="top-right" />
      </mapbox-map>
    </client-only>
    <div class="search-map__result">
      <div class="search-map__list">
        <UserMap
          v-for="(item, index) in result"
          :key="index"
          :data="item"
          type="small"
          @click.native="onActive(index, item)"
          :class="{ 'is-active': indexActive == index }"
        />
      </div>
      <transition name="slideUp">
        <div v-if="dataActive !== null" class="search-map__information">
          <div class="search-map-pc">
            <div
              v-if="dataActive.media_files_in_search"
              class="search-map__gallery"
            >
              <div
                v-for="(media, index) in dataActive.media_files_in_search"
                :key="index"
                @click="galleryIndex = index"
              >
                <blur-hash-image
                  v-if="media.media_file.blurhash"
                  :hash="media.media_file.blurhash"
                  :src="`/storage/${media.media_file.preview_url}`"
                  class="blurhash"
                />
              </div>
            </div>
            <div>
              <Button :to="localePath(`/users/${dataActive.username}`)">
                Go to profile
              </Button>
            </div>
          </div>
          <div class="search-map-mobile">
            <div class="search-map__close" @click="unActive()">
              <span></span>
            </div>
            <swiper class="search-map__gallery" :options="swiperMainOptions">
              <swiper-slide
                v-for="(item, index) in dataActive.media_files_in_search"
                :key="index"
              >
                <div @click="galleryIndex = index">
                  <blur-hash-image
                    v-if="item.media_file.blurhash"
                    :hash="item.media_file.blurhash"
                    :src="`/storage/${item.media_file.preview_url}`"
                    class="blurhash"
                  />
                </div>
              </swiper-slide>
              <div class="swiper-pagination" slot="pagination"></div>
            </swiper>
            <div class="user__info">
              <nuxt-link
                class="user__top"
                :to="localePath(`/users/${dataActive.id}`)"
                v-wave
              >
                <Avatar class="user__photo" :user="dataActive" />
                <div>
                  <div class="user__username">
                    {{ dataActive.display_name }}
                  </div>
                  <div class="user__slogan">{{ dataActive.slogan }}</div>
                </div>
                <svg-icon name="arrow-line" />
              </nuxt-link>
              <div class="user__stats">
                <nuxt-link
                  class="item"
                  :to="localePath(`/users/${dataActive.username}`)"
                >
                  <div class="content">
                    <div class="value">0%</div>
                    <div class="label">Good reviews</div>
                  </div>
                </nuxt-link>
                <div
                  class="item"
                  v-if="
                    dataActive.in_favorites_aggregate &&
                    dataActive.in_favorites_aggregate.aggregate
                  "
                  v-wave
                >
                  <div class="content">
                    <div class="value">
                      {{ dataActive.in_favorites_aggregate.aggregate.count }}
                    </div>
                    <div class="label">Likes</div>
                  </div>
                  <div class="icon">
                    <svg-icon name="like" />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <CoolLightBox
            :items="gallery(dataActive.media_files_in_search)"
            :index="galleryIndex"
            @close="galleryIndex = null"
          ></CoolLightBox>
        </div>
      </transition>
      <div
        v-if="indexActive !== null"
        class="search-map__overlay search-map-mobile"
        @click="unActive()"
      ></div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from '@nuxtjs/composition-api'

import Avatar from '@/components/ui/Avatar.vue'
import Button from '@/components/ui/Button.vue'
import UserMap from '@/components/search/UserMap.vue'

// @ts-ignore TODO
import CoolLightBox from 'vue-cool-lightbox'
import '@/assets/scss/vue-cool-lightbox.scss'

import { Swiper, SwiperSlide, directive } from 'vue-awesome-swiper'
import 'swiper/css/swiper.css'

export default defineComponent<{
  data: any
  result: any
}>({
  name: 'PrivatePage',
  props: ['data', 'result'],
  components: { Avatar, Button, UserMap, CoolLightBox, Swiper, SwiperSlide },
  directives: {
    swiper: directive
  },
  setup(props, { root }) {
    const galleryIndex = ref(null)
    const gallery = (media: any) => {
      return media.map(function (item: any) {
        return {
          src: `/storage/${item.media_file.preview_url}`
        }
      })
    }

    const mapStyle = 'mapbox://styles/alexkharech/ckdj217qt152z1itlob2njbl4?v2'
    const indexActive = ref(null)
    const dataActive = ref(null)
    const onActive = (index: any, data: any, geo: any) => {
      if (indexActive.value !== index) {
        indexActive.value = index
        dataActive.value = data
      } else {
        indexActive.value = null
        dataActive.value = null
      }
    }
    const unActive = (index: any, data: any, geo: any) => {
      indexActive.value = null
      dataActive.value = null
    }

    const swiperMainOptions = {
      slidesPerView: 1,
      spaceBetween: 0,
      loop: false,
      pagination: {
        el: '.swiper-pagination',
        clickable: true
      }
    }

    watch(
      () => props.result,
      () => {
        indexActive.value = null
      }
    )
    return {
      gallery,
      galleryIndex,
      indexActive,
      dataActive,
      onActive,
      unActive,
      swiperMainOptions
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';
.search-map {
  height: calc(100vh - 55px);
  overflow: hidden;
  position: relative;
  @media (min-width: 991.98px) {
    height: calc(100vh - 85px);
  }
  &-pc {
    display: none;
    @media (min-width: 991.98px) {
      display: block;
    }
  }
  &-mobile {
    display: block;
    @media (min-width: 991.98px) {
      display: none;
    }
  }
  &__container {
    height: 100%;
  }
  &__result {
    position: absolute;
    left: 0px;
    right: 0px;
    bottom: 0px;
    top: 0px;
    pointer-events: none;
    z-index: 999;
    @media (min-width: 991.98px) {
      left: 20px;
      top: 20px;
      bottom: 20px;
      right: initial;
    }
  }
  &__list {
    pointer-events: all;
    background: #272c3a;
    border-radius: 8px;
    width: 350px;
    overflow-y: auto;
    overflow-x: hidden;
    height: 100%;
    display: none;
    z-index: 10;
    @media (min-width: 991.98px) {
      display: block;
    }
    &::-webkit-scrollbar {
      width: 8px;
      height: 8px;
    }
    &::-webkit-scrollbar-track {
      background-color: transparent;
    }
    &::-webkit-scrollbar-thumb {
      background: #0065ff;
      -webkit-border-radius: 80px;
      border-radius: 80px;
    }
  }
  &__information {
    pointer-events: all;
    position: absolute;
    left: 0;
    right: 0;
    bottom: 0px;
    background: #272c3a;
    overflow-y: auto;
    overflow-x: hidden;
    width: 100%;
    z-index: 10;
    @media (min-width: 991.98px) {
      right: inherit;
      left: 100%;
      top: 0px;
      width: 350px;
      margin-left: 2px;
      padding: 20px;
      border-radius: 8px;
      > div.hide-mobile {
        display: flex !important;
        flex-direction: column;
        justify-content: space-between;
        min-height: 100%;
      }
    }
    &::-webkit-scrollbar {
      width: 8px;
      height: 8px;
    }
    &::-webkit-scrollbar-track {
      background-color: transparent;
    }
    &::-webkit-scrollbar-thumb {
      background: #0065ff;
      -webkit-border-radius: 80px;
      border-radius: 80px;
    }
  }
  &__gallery {
    @media (min-width: 991.98px) {
      margin-bottom: 20px;
    }
    > div {
      @media (min-width: 991.98px) {
        margin-bottom: 10px;
        border-radius: 10px;
        overflow: hidden;
        &:last-child {
          margin-bottom: 0px;
        }
      }
    }
    ::v-deep {
      .blurhash {
        padding: 0 !important;
        height: 250px;
        @media (min-width: 991.98px) {
          height: 190px;
        }
      }
      img {
        object-fit: cover !important;
      }
    }
  }
  &__overlay {
    position: fixed;
    left: 0px;
    top: 0px;
    bottom: 0px;
    right: 0px;
    z-index: 9;
    background-color: rgba(#1f232f, 0.8);
    transition: 0.2s all ease;
    pointer-events: all;
  }
  &__close {
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    cursor: pointer;
    z-index: 99;
    text-align: center;
    padding: 10px;
    font-size: 0px;
    span {
      display: inline-block;
      width: 35px;
      height: 5px;
      background-color: #282e40;
      border-radius: 4px;
    }
  }
  .profile-is-active {
    box-shadow: 0 0 0 4px #0065ff;
  }
}

.user {
  &__info {
    padding: 15px;
    background-color: #1f232f;
  }
  &__top {
    display: flex;
    align-items: center;
    font-size: 0px;
    padding: 14px 15px;
    background: #282e40;
    border-radius: 12px;
    margin-bottom: 10px;
    & > * {
      flex: 1;
    }
    svg {
      width: 35px;
      height: 35px;
      background-color: #0065ff;
      border-radius: 50%;
      fill: #ffffff;
      padding: 11px;
      flex: none;
      margin-left: 15px;
    }
  }
  &__photo {
    flex: none;
    margin-right: 15px;
    height: 42px;
    width: 42px;
  }
  &__username {
    letter-spacing: 0px;
    color: #ffffff;
    font-size: 18px;
    line-height: 18px;
    font-weight: 500;
    margin-bottom: 3px;
    &:last-child {
      margin-bottom: 0px;
    }
  }
  &__slogan {
    letter-spacing: 0px;
    color: #7683ad;
    font-size: 16px;
    line-height: 16px;
    font-weight: 500;
  }
  &__stats {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-gap: 10px;
    .item {
      background: #282e40;
      border-radius: 12px;
      padding: 10px 15px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      .content {
        flex: 1;
        padding-right: 15px;
        &:last-child {
          padding-right: 0px;
        }
      }
      .value {
        display: block;
        color: #ffffff;
        font-weight: bold;
        font-size: 24px;
        line-height: 30px;
      }
      .label {
        display: block;
        letter-spacing: 0px;
        color: #7683ad;
        font-weight: 500;
        font-size: 16px;
        line-height: 20px;
      }
      .icon {
        flex: none;
        overflow: hidden;
        font-size: 0px;
      }
      svg {
        background: #454e6a;
        width: 50px;
        height: 50px;
        padding: 15px;
        border-radius: 50%;
        fill: #fff;
        &.is-active {
          fill: #f00;
        }
      }
    }
  }
}
</style>
